package CGI.Characters is
  -- In order to pass special characters (especially HTML code) within
  -- CGI parameters, it is encoded. There does not appear to be much
  -- standardization, so these utilities do what works. This prevents
  -- special delimeters from being confused as formatting commands.

  function Decode (Encoded : in String) return String;
  function Encode (HTML    : in String) return String;

----------------------------
-- Special characters may be coded according to the following patterns from
-- <a href=http://www.utirc.utoronto.ca/HTMLdocs/NewHTML/iso_table.html>a complete table</a>
-- These are always prefixed with an '&' and end with ';'.
--
  Quote : constant String := "quot";
  Ampersand : constant String := "amp";
  Less_Than : constant String := "lt";
  Greater_Than : constant String := "gt";

end CGI.Characters;
