-- <a href="http://hoohoo.ncsa.uiuc.edu/cgi/env.html">Documentation</a>
package CGI.Environment is

-- In order to pass data about the information request from the server to
-- the script, the server uses command line arguments as well as
-- environment variables. These environment variables are set when the
-- server executes the gateway program.

-- This API provides two ways to access environment variable values. The
-- enumerated type with a parameterized function, or individual functions
-- for each environment variable. First the enumerated type for a quick
-- reference, and then individual functions with documentation.

  type Variable is  -- <a href="http://hoohoo.ncsa.uiuc.edu/cgi/env.html">Documentation</a>
    (Server_Software,
     Server_Name,       
     Gateway_Interface, 
     Server_Protocol,   
     Server_Port,       
     Request_Method,    
     Path_Info,         
     Path_Translated,   
     Script_Name,       
     Query_String,      
     Remote_Host,       
     Remote_Addr,       
     Auth_Type,         
     Remote_User,       
     Remote_Ident,      
     Content_Type,      
     Content_Length,    
     HTTP_Accept,       
     HTTP_User_Agent);  

  function Value (Name : Variable) return String;

  -----------------
  -- The following Variables have a type to which the String can
  -- be converted.
  function Server_Port return Natural;
    -- The port number to which the request was sent.

  function Content_Length return Natural;
    -- The length of the said content as given by the client.
    
end CGI.Environment;
