with Ada.Text_IO;
package body CGI.Output is

  -- Don't let the program set the Content more than once:
  Content_Set : Boolean := False;

  -- In case the program "crashes", flush the output buffer after
  -- each IO. This helps debugging, but takes a performance hit.
  
  
  procedure Content_Text_HTML is
  begin
    if Content_Set then
      raise Program_Error;
    else
      -- Output must have a mime/type
      Ada.Text_IO.Put_Line ("Content-type: text/html");
      Ada.Text_IO.New_Line;
      Ada.Text_IO.Flush;
      Content_Set := True;
    end if;
  end;

  procedure Put      (Text : in String) is
  begin
    Ada.Text_IO.Put(Text);
    Ada.Text_IO.Flush;
  end;
  
  procedure Put_Line (Text : in String) is
  begin
    Ada.Text_IO.Put_Line(Text);
    Ada.Text_IO.Flush;
  end;

  procedure New_Line is
  begin
    Ada.Text_IO.New_Line;
    Ada.Text_IO.Flush;
  end;
    
end CGI.Output;
