with Ada.Text_IO;
with CGI.Environment;

package body CGI is

---------------------
-- Retrieve <a href="http://hoohoo.ncsa.uiuc.edu/cgi/in.html">CGI Input</a>:
---------------------
  function Get_Method return Request_Method is
    Request_Method_Text : constant String
      := CGI.Environment.Value(CGI.Environment.Request_Method);
  begin
    return Request_Method'Value(Request_Method_Text);
  exception
    when others => return Unknown;
  end Get_Method;
  
R_M : constant Request_Method := Get_Method;
  
  function Get_String_Input return String is
    use CGI.Environment;
  begin
    case R_M is
      when Get  => return Value(Query_String);
      when Post =>
        declare
          Input_Length : Natural := Content_Length;
          Input_String : String(1..Input_Length);
        begin
          Ada.Text_IO.Get(Input_String);
          return Input_String;
        end;
      when others => return "";
    end case;
  end Get_String_Input;

Input_String : constant String := Get_String_Input;

---------------------
-- Retrieval Complete
---------------------

  -------------------------------
  function Input return String is
  begin
    return Input_String;
  end;
  
  function Method return Request_Method is
  begin
    return R_M;
  end;

end CGI;
