with System;
with Ada.Text_IO;

package body GNAT_Compiler is

  procedure Compile (Source_File  : in     String;
                     GNAT_Options : in     String; -- 'c' is always used
                     Has_Errors   :    out Boolean) is

    procedure Invoke(Command : String) is

      function Call_System(Command : System.Address) return Integer;
      pragma Import(C, Call_System, "system");

      C_Command : String (1..Command'Length +1);
    begin
      C_Command(1..Command'Length) := Command;
      C_Command(C_Command'Last)    := Ascii.nul;

      Ada.Text_IO.Flush; -- to keep from interleaving output
      Has_Errors := Call_System(C_Command'Address) /= 0;
      Ada.Text_IO.Flush; -- to keep from interleaving output
    end Invoke;

  begin
    Invoke ("gcc -c -gnatc" & Gnat_Options & " " & Source_File);
  end Compile;

end GNAT_Compiler;
