package HTML is
  function Start_HTML               return String;
  function Head  (Text : in String) return String;
  function Title (Text : in String) return String;
  function Start_Body               return String;

  -- Header --------
  type H_Align is (Left, Center, Right);
  function Header (Text  : in String;
                   Level : in Natural := 1;
                   Align : in H_Align := Left) return String;

  -- Style ---------
  function Bold      (Text : in String) return String;
  function Italics   (Text : in String) return String;
  function Paragraph                    return String;

  -- Definition ----
  function Start_Def_List return String;
    function Define (Term       : in String;
                     Definition : in String) return String;
  function End_Def_List return String;

  -- Table ---------
  function Table (Border : in Boolean := False) return String;
    function Row return String;
      function Table_Header (Text     : in String;
                             Span_Row : in Natural := 1;
                             Span_Col : in Natural := 1) return String;
      function Cell (Text     : in String;
                     Span_Row : in Natural := 1;
                     Span_Col : in Natural := 1) return String;
  function End_Table return String;
  

  package Abbreviations is
    function B(Text : in String) return String renames Bold;
    function I(Text : in String) return String renames Italics;
    function P                   return String renames Paragraph;
    function TH (Text     : in String;
                 Span_Row : in Natural := 1;
                 Span_Col : in Natural := 1) return String renames Table_Header;
    function TD (Text     : in String;
                 Span_Row : in Natural := 1;
                 Span_Col : in Natural := 1) return String renames Cell;
  end Abbreviations;

  function End_Body_HTML return String;
end HTML;
